/*******************************************************************************
 * Copyright (c) 2009 Information-technology Promotion Agency, Japan.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *******************************************************************************/
package benten.cat.validation;

import java.io.InputStream;

import jp.sourceforge.mergedoc.pleiades.resource.PropertySet;

import org.osgi.framework.BundleContext;

import benten.core.AbstractBentenPlugin;

/**
 * CAT 検証プラグインです。
 */
public class CatValidationPlugin extends AbstractBentenPlugin {

	/** 共用インスタンス */
	private static CatValidationPlugin plugin;

	/** 用語検証プロパティー */
	public static PropertySet vTermProp = new PropertySet();

	/** 対訳正規表現セット */
	public static PropertySet vTranslationProp = new PropertySet();

	/**
	 * コンストラクター。
	 */
	public CatValidationPlugin() {
	}

	@Override
	public void start(BundleContext context) throws Exception {
		super.start(context);
		plugin = this;

		// 用語検証プロパティーのロード
		vTermProp.load(getInputStream("validation-term.properties"));

		// 対訳正規表現セットのロード
		vTranslationProp.load(getInputStream("/validation-translation.properties"));

		//TODO その他のプロパティーをロード
	}

	private InputStream getInputStream(String fileName) {
		return getClass().getClassLoader().getResourceAsStream("conf/props/" + fileName);
	}

	@Override
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/**
	 * このプラグインの共用インスタンスを取得。
	 * @return このプラグインの共用インスタンス
	 */
	public static CatValidationPlugin getDefault() {
		return plugin;
	}
}
